import greenfoot.GreenfootImage;
import java.util.List;

/**
 * GateAccess
 * 
 * @author Taylor Born
 * @version January 2014
 */
public class GateAccess extends GameObject
{
    private static final GreenfootImage CLOSED = new GreenfootImage("GateAccessClosed.png");
    private static final GreenfootImage OPEN = new GreenfootImage("GateAccessOpen.png");
    

    private char id;
    private InputWindow inputWindow;

    public GateAccess(char id)
    {
        this.id = id;
        inputWindow = new InputWindow("Input Access Key " + Terrain.main.accessKeyPrefix(true) + "-" + id + ":", Terrain.ACCESS_KEY_LENGTH);
        setImage(CLOSED);
    }
    
    @Override
    public void act()
    {
        String result = inputWindow.getResult();
        if (result != null && result.equals(Terrain.main.getKey(id, true)))
        {
            for (Gate g : (List<Gate>)getWorld().getObjects(Gate.class))
                if (g.getID() == id)
                {
                    getWorld().removeObject(g);
                    break;
                }
            setImage(OPEN);
        }
        
        if (getImage() == CLOSED && onThis(Terrain.main.getPlayer()) && KeysPressed.testKey("e") && !inputWindow.inWorld())
            inputWindow.toggleShow("");
    }
}