import greenfoot.Actor;
import greenfoot.World;

/**
 * Translatable
 * 
 * @author Taylor Born
 * @version May 2012
 */
public abstract class Translatable extends Actor
{
    protected double x, y;
    
    public void translate(double a, double b)
    {
        x += a;
        y += b;
        setLocation((int)Math.ceil(x), (int)Math.ceil(y));
    }
    public void addedToWorld(World world)
    {
        x = getX();
        y = getY();
    }
    protected boolean withinDistance(int bX, int bY, int distance)
    {
        return distanceFrom(bX, bY) < distance;
    }
    protected double distanceFrom(double x, double y)
    {
        return Math.sqrt(Math.pow(this.x - x, 2) + Math.pow(this.y - y, 2));
    }
    public double getPosX()
    {
        return x;
    }
    public double getPosY()
    {
        return y;
    }
    public void setPos(double a, double b)
    {
        x = a;
        y = b;
        setLocation((int)Math.ceil(x), (int)Math.ceil(y));
    }
    public void remove()
    {
        getWorld().removeObject(this);
    }
}