import greenfoot.GreenfootImage;
import java.awt.Point;

/**
 * Tree
 * 
 * @author Taylor Born
 * @version May 2012
 */
public class Tree extends GameObject
{
    private TreePart[] parts = new TreePart[9];
    private int n = 0;

    public Tree()
    {
        for (int i = 0; i < parts.length; i++)
            parts[i] = new TreePart(i < 4 ? -1 : i - 4);
    }
    private void directParts()
    {
        double x = getX();
        double y = getY();
        
        Point pos = new Point(Terrain.main.getPlayer().getX(), Terrain.main.getPlayer().getY());
        double a = Math.atan2(y - pos.getY(), x - pos.getX());
        double d = Math.sqrt(Math.pow(pos.getX() - x, 2) + Math.pow(pos.getY() - y, 2));
        for (int i = 0; i < 4; i++)
            if (parts[i].getWorld() != null)
                parts[i].setLocation((int)(x + Math.cos(a) * d / 8 * (.1 * i)), (int)(y + Math.sin(a) * d / 8 * (.1 * i)));
        for (int i = 0; i < 5; i++)
            if (parts[i + 4].getWorld() != null)
                parts[i + 4].setLocation((int)(x + Math.cos(a) * d / 8 * (.6 + .3 * i)), (int)(y + Math.sin(a) * d / 8 * (.6 + .3 * i)));
    }
    public void remove()
    {
        for (TreePart p : parts)
            getWorld().removeObject(p);
        super.remove();
    }
    public void translate(double x, double y)
    {
        super.translate(x, y);
        if (getX() > -30 && getX() < getWorld().getWidth() + 30 && getY() > -30 && getY() < getWorld().getHeight() + 30)
        {
            if (n < parts.length)
                getWorld().addObject(parts[n++], getX(), getY());
            directParts();
        }
        else if (n > 0)
            getWorld().removeObject(parts[--n]);
    }
}